from typing import TypeVar
from bson.objectid import ObjectId

IntStr = TypeVar('IntStr', int, str)
IntFloat = TypeVar('IntFloat', int, float)


class MdbObjectId(ObjectId):
    @classmethod
    def __get_validators__(cls):
        yield cls.validate

    @classmethod
    def validate(cls, v):
        try:
            res = ObjectId(v)
        except:
            raise TypeError('不能装换为 ObjectId')
        else:
            return res
