import pymongo

from settings import settings


def get_local_db(db_name):
    db_client = pymongo.MongoClient(settings.local_mongo_uri)
    return db_client[db_name]


def get_remote_db(db_name):
    db_client = pymongo.MongoClient(settings.remote_mongo_uri)
    return db_client[db_name]
